//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/RiffChunk.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: RiffChunk.c,v 1.6 2004/04/20 22:26:22 ah Exp $ (c) 1999 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/IO/Riff/Chunk.h>
#include <AH/IO/Convert.h>
USING_NAMESPACE(AH)

#include <string>
#include <iostream>
USING_NAMESPACE(std)

// --- member functions ---

BEGIN_NAMESPACE(AH)

// constructor
IORiffChunk::IORiffChunk(const uint8* chunkbuf)
    : heapchunk(0),
      chunk(chunkbuf), 
      remSize(IOConvert::LittleEndCharsToUint32(chunk+4)), 
      onHeap(false)
{
    memcpy(id, chunk, 4);
    id[4] = '\0';
}


// constructor
IORiffChunk::IORiffChunk
(
    const char* Id, 
    uint8* Data, 
    uint32 Size
)
    : heapchunk(new uint8[Data ? Size : IORiffChunk::size]),
      chunk(heapchunk),
      remSize(Size),
      onHeap(heapchunk ? true : false)
{
    if (!chunk) throw ErrorSys(ENOMEM);

    // copy ID into chunk, keep copy as well:
    memcpy(heapchunk, Id, 4);
    memcpy(id, heapchunk, 4);
    id[4] = '\0';

    // copy size into chunk
    IOConvert::Uint32ToLittleEndChars(remSize, heapchunk+4);

    // copy remaining data into chunk:
    if (remSize && Data) memcpy(heapchunk+8, Data, remSize);
}

// destructor
IORiffChunk::~IORiffChunk() 
{
    if (onHeap) delete[] heapchunk;
}


ostream& IORiffChunk::printInfo(ostream& out, const char* pre)
{
    if (pre) out << pre;
    out << "\"" << id << "\": " << remSize << " bytes" << endl;
    return out;
}

END_NAMESPACE
