//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/RiffStartChunk.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: RiffStartChunk.c,v 1.6 2004/04/20 22:26:22 ah Exp $ (c) 1999 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/IO/Riff/StartChunk.h>
#include <AH/IO/Riff/Error.h>
USING_NAMESPACE(AH)

#include <string>
#include <iostream>
USING_NAMESPACE(std)

BEGIN_NAMESPACE(AH)

// constructor
IORiffStartChunk::IORiffStartChunk(const unsigned char* data)
    : IORiffChunk(data)
{
    memcpy(type, IORiffChunk::chunkData(), 4);
    type[4] = '\0';
    if (0 != strcmp("RIFF", getID())) throw ErrorIORiffInvalidFormat();
}


// constructor
IORiffStartChunk::IORiffStartChunk(uint32 fileSize, const char* t)
    : IORiffChunk("RIFF", 0, fileSize - 8)
{
    if (t) strncpy(type, t, 4);
    else   strcpy(type, "WAVE");
    memcpy((uint8*)IORiffChunk::chunkData(), type, 4);
}


ostream& IORiffStartChunk::printInfo(ostream& out, const char* pre)
{
    if (pre) out << pre;
    out << "\"" << getID() << "\" (" << type << "): " << getDataSize()
	<< " bytes" << endl;
    return out;
}

END_NAMESPACE
